#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <commctrl.h>

#if _WIN32_WCE > 299
#define _POCKETPC
#include <aygshell.h>
#include <sipapi.h>
#pragma comment (lib, "aygshell.lib")
#endif

#define MENU_HEIGHT 26

#ifdef _POCKETPC
#include "ppc/resource.h"
#else
#include "ce2/resource.h"
#endif

TCHAR Platform[256] = TEXT("");
TCHAR OsVer[256] = TEXT("");
#ifdef MIPS
TCHAR CpuType[16] = TEXT("MIPS");
#endif
#ifdef SH3
TCHAR CpuType[16] = TEXT("SH3");
#endif
#ifdef SH4
TCHAR CpuType[16] = TEXT("SH4");
#endif
#ifdef ARM
TCHAR CpuType[16] = TEXT("StrongARM");
#endif
#ifdef x86
TCHAR CpuType[16] = TEXT("x86");
#endif

LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About  (HWND, UINT, WPARAM, LPARAM);
void BenchLog ();

int		g_nNowBen = -1;	//ŋߌvڔԍ
DWORD	g_dwTimes[10];	//v
HINSTANCE g_hInstance;	//CX^X
HWND	g_hwndCB;		//c[o[

#define NAME_CLASS TEXT("BMQ")
#define NAME_TITLE TEXT("BMQ")

//--------------------------------------
void GetPlatform ()
{
	HKEY hKey;
	DWORD dwType;
	TCHAR buf[MAX_PATH];
	DWORD len;
	long rc;

	rc = RegOpenKeyEx (HKEY_LOCAL_MACHINE, TEXT("Platform"), 
		0, KEY_QUERY_VALUE, &hKey);
	if (rc != ERROR_SUCCESS) {
		return;
	}

	len = sizeof(buf) - 1;
	rc = RegQueryValueEx(hKey, TEXT("Name"), NULL, &dwType, (LPBYTE)buf, &len);
	if (rc == ERROR_SUCCESS) {
		lstrcpy (Platform, buf);
	}

	RegCloseKey(hKey);
}

//--------------------------------------
void GetOSVersion ()
{
	OSVERSIONINFO ovi;
	memset (&ovi, 0, sizeof(ovi));
	ovi.dwOSVersionInfoSize = sizeof(ovi);
	GetVersionEx (&ovi);

	wsprintf (OsVer, TEXT("CE%2d.%02d (Build %d)")
		,ovi.dwMajorVersion
		,ovi.dwMinorVersion
		,ovi.dwBuildNumber
		);
}

//--------------------------------------
int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow )
{
	g_hInstance = hInstance;

	GetPlatform ();
	GetOSVersion ();

	// R Rg[̃R}h o[ NX[h
	{
		INITCOMMONCONTROLSEX icex;
		icex.dwSize = sizeof (INITCOMMONCONTROLSEX);
		icex.dwICC = ICC_BAR_CLASSES | ICC_TREEVIEW_CLASSES | ICC_LISTVIEW_CLASSES;
		InitCommonControlsEx (&icex);
	}

	WNDCLASS	wc;
    wc.style			= CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc		= (WNDPROC) WndProc;
    wc.cbClsExtra		= 0;
    wc.cbWndExtra		= 0;
    wc.hInstance		= hInstance;
    wc.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_MAIN));
    wc.hCursor			= 0;
    wc.hbrBackground	= (HBRUSH) GetStockObject(WHITE_BRUSH);
    wc.lpszMenuName		= 0;
    wc.lpszClassName	= NAME_CLASS;
#ifdef _WIN32_WCE
#else
	wcex.lpszMenuName	= (LPCSTR)IDC_BMQ;
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
#endif
	RegisterClass(&wc);

	HWND hWnd;
#ifdef _WIN32_WCE
	hWnd = CreateWindow (NAME_CLASS, NAME_TITLE, WS_VISIBLE,
		CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);
#else
	hWnd = CreateWindow (NAME_CLASS, NAME_TITLE, WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);
#endif
	if (!hWnd) {
		return FALSE;
	}

	HICON hIcon = (HICON)LoadImage (hInstance, MAKEINTRESOURCE(IDI_MAIN), 
		IMAGE_ICON, 16, 16, 0);
	SendMessage (hWnd, WM_SETICON, FALSE, (LPARAM)hIcon);

#ifdef _POCKETPC
	{
		RECT rc;
		GetWindowRect(hWnd, &rc);
		rc.bottom -= MENU_HEIGHT;
		MoveWindow (hWnd, 0, MENU_HEIGHT, rc.right, rc.bottom, FALSE);
	}
#endif

	ShowWindow (hWnd, nCmdShow);
	UpdateWindow (hWnd);
#ifdef _WIN32_WCE
	if (g_hwndCB)
		CommandBar_Show (g_hwndCB, TRUE);
#endif

	HACCEL hAccelTable;
	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_MAIN);

	MSG msg;
	while (GetMessage(&msg, NULL, 0, 0)) {
		if (!TranslateAccelerator (msg.hwnd, hAccelTable, &msg)) {
			TranslateMessage (&msg);
			DispatchMessage  (&msg);
		}
	}

	return msg.wParam;
}

//--------------------------------------
//P̐vZ
int IntegerCalculationOne (DWORD i)
{
	int j;
	int a[256];

	a[0] = rand();
	a[1] = (i%256)+2;
	a[2] = a[0] + a[1];
	a[3] = a[2] / a[1];
	a[4] = a[3] - a[1];
	a[5] = a[4] * a[1];
	a[6] = a[5] % a[1];
	for (j = 0; j < 7; j++) {
		a[7] += a[j];
	}
	return a[7];
}

//--------------------------------------
//vZv
DWORD IntegerCalculation ()
{
	DWORD dwTick;
	DWORD dwNow;
	DWORD i;
	DWORD j;
	int   a = 0;

	dwTick = GetTickCount ();

	for (i = 0;; i++) {
		for (j = 0; j < 1000; j++) {
			a += IntegerCalculationOne (j);
		}
		//Pbo߂I
		dwNow = GetTickCount ();
		if (dwNow - dwTick >= 1000)
			break;
	}

	return i;
}

//--------------------------------------
//P̕_Z
double FloatingPointArithmeticOne (DWORD i)
{
	int j;
	double a[256];

	a[0] = rand();
	a[1] = (i%256)+2;
	a[2] = a[0] + a[1];
	a[3] = a[2] / a[1];
	a[4] = a[3] - a[1];
	a[5] = a[4] * a[1];
	for (j = 0; j < 7; j++) {
		a[7] += a[j];
	}
	return a[7];
}
//--------------------------------------
//_Zv
DWORD FloatingPointArithmetic ()
{
	DWORD dwTick;
	DWORD dwNow;
	DWORD i;
	DWORD j;
	double a = 0;

	dwTick = GetTickCount ();

	for (i = 0;; i++) {
		for (j = 0; j < 1000; j++) {
			a += FloatingPointArithmeticOne (j);
		}
		//Pbo߂I
		dwNow = GetTickCount ();
		if (dwNow - dwTick >= 1000)
			break;
	}

	return i;
}

//--------------------------------------
//`摬xv
DWORD PaintingPictures (HWND hWnd)
{
	DWORD dwTick;
	DWORD dwNow;
	DWORD i;
	int x, y;

	RECT rect;
	GetClientRect (hWnd, &rect);
	if (rect.right >= 320) {
		rect.right  = 320;
		rect.bottom = 240;
	}
	else if (rect.bottom >= 320) {
		rect.right  = 240;
		rect.bottom = 320;
	}

	HICON hIcon = LoadIcon (g_hInstance, (LPTSTR)IDI_TEST);
	HBITMAP hBitmap = LoadBitmap (g_hInstance, (LPTSTR)IDB_TEST);

	BITMAP bm;
	GetObject (hBitmap, sizeof(BITMAP), &bm);

	HDC hDC = GetDC (hWnd);

	HDC hVDC = CreateCompatibleDC (hDC);
	HBITMAP hBmpold = (HBITMAP) SelectObject (hVDC, hBitmap);

	ReleaseDC (hWnd, hDC);

	dwTick = GetTickCount ();

	for (i = 0;; i++) {
		hDC = GetDC (hWnd);
		//rbgC[W
		if ((i % 4) == 0) {
			StretchBlt (hDC, 0,0, rect.right, rect.bottom, 
				hVDC, 0,0, bm.bmWidth, bm.bmHeight, SRCCOPY);
		}
		else {
			x = rand() % (rect.right - bm.bmWidth);
			y = rand() % (rect.bottom - bm.bmHeight);
			BitBlt (hDC, x, y, bm.bmWidth, bm.bmHeight, hVDC, 0,0, SRCCOPY);
			if ((i % 4) == 1)
				FillRect (hDC, &rect, (HBRUSH) GetStockObject(WHITE_BRUSH));
		}
		//܂ɂ̓ACR\Ă݂
		if ((i % 10) == 0) {
			x = rand() % (rect.right - 32);
			y = rand() % (rect.bottom - 32);
			DrawIcon (hDC, x, y, hIcon);
		}
		ReleaseDC (hWnd, hDC);
		UpdateWindow (hWnd);
		//Pbo߂I
		dwNow = GetTickCount ();
		if (dwNow - dwTick >= 4000)
			break;
	}

	if (hBmpold) SelectObject (hVDC, hBmpold);
	DeleteDC (hVDC);

	if (hBmpold) DeleteObject (hBmpold);
	if (hIcon) DeleteObject (hIcon);

	return i;
}

//--------------------------------------
//EChE`揈v
DWORD WindowsTexts (HWND hWnd)
{
	HWND hItem[8];
	int i;
	TCHAR buf[256];
	int x, y;
	DWORD dwTick;
	DWORD dwNow;

	dwTick = GetTickCount ();

	RECT rect;
	GetClientRect (hWnd, &rect);

	x = 0;
	y = 24;

	hItem[0] = CreateWindow (TEXT("BUTTON"), TEXT("TEST"), WS_VISIBLE | BS_PUSHBUTTON | BS_TEXT,
		x, y, 60, 20, hWnd, NULL, g_hInstance, NULL);
	SetWindowText (hItem[0], TEXT("TEST"));
	x += 60;

//	MessageBox (hWnd, TEXT("BUTTON"), TEXT("debug"), MB_OK);

	hItem[1] = CreateWindow (TEXT("COMBOBOX"), TEXT("TEST"),WS_VISIBLE | WS_BORDER /*| CBS_SIMPLE*/,
		x, y, 60, 80, hWnd, NULL, g_hInstance, NULL);
	for (i = 0; i < 32; i++) {
		wsprintf (buf, TEXT("test%d"), i);
		SendMessage (hItem[1], CB_ADDSTRING, 0, (LPARAM)buf);
	}
	x += 60;

//	MessageBox (hWnd, TEXT("COMBOBOX"), TEXT("debug"), MB_OK);

	hItem[2] = CreateWindow (TEXT("EDIT"), TEXT("TEST"),WS_VISIBLE | WS_BORDER | ES_LEFT,
		x, y, 60, 24, hWnd, NULL, g_hInstance, NULL);
	SetWindowText (hItem[2], TEXT("TEST"));
	x += 60;

//	MessageBox (hWnd, TEXT("EDIT"), TEXT("debug"), MB_OK);

	hItem[3] = CreateWindow (TEXT("LISTBOX"), TEXT("TEST"),WS_VISIBLE | WS_BORDER | WS_VSCROLL | LBS_SORT,
		x, y, 60, 80, hWnd, NULL, g_hInstance, NULL);
	for (i = 0; i < 32; i++) {
		wsprintf (buf, TEXT("test%d"), i);
		SendMessage (hItem[3], LB_ADDSTRING, 0, (LPARAM)buf);
	}
	x += 60;

//	MessageBox (hWnd, TEXT("LISTBOX"), TEXT("debug"), MB_OK);

	x = 0;
	y = 120;

	hItem[4] = CreateWindow (TEXT("STATIC"), TEXT("TEST"),WS_VISIBLE | WS_BORDER | SS_LEFT,
		x, y, 60, 16, hWnd, NULL, g_hInstance, NULL);
	SetWindowText (hItem[4], TEXT("TEST"));
	x += 60;

//	MessageBox (hWnd, TEXT("STATIC"), TEXT("debug"), MB_OK);

	HICON hIcon = (HICON)LoadImage (g_hInstance, MAKEINTRESOURCE(IDI_MAIN), 
		IMAGE_ICON, 16, 16, 0);

	HIMAGELIST himl;
	himl = ImageList_Create (16, 16, ILC_COLOR, 1, 0);
	ImageList_AddIcon (himl, hIcon);

	hItem[5] = CreateWindowEx (WS_EX_CLIENTEDGE, WC_TREEVIEW, NULL, 
		WS_TABSTOP | WS_VISIBLE | WS_CHILD | 
		TVS_HASBUTTONS | TVS_HASLINES | TVS_SHOWSELALWAYS | TVS_LINESATROOT,
		x, y, 60, 80, hWnd, (HMENU)50100, g_hInstance, NULL);
	x += 60;

	TreeView_SetImageList (hItem[5], himl, TVSIL_NORMAL);

	TVINSERTSTRUCT tvis;
	tvis.hParent      = NULL;
	tvis.hInsertAfter = TVI_SORT;
	tvis.item.mask    = TVIF_TEXT | TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_CHILDREN;
	tvis.item.pszText = TEXT("Tree");
	tvis.item.iImage  = 0;
	tvis.item.iSelectedImage = 0;
	tvis.item.cChildren = 1;
	TreeView_InsertItem(hItem[5], &tvis);

	hItem[6] = CreateWindowEx (WS_EX_CLIENTEDGE, WC_LISTVIEW, NULL, 
		WS_TABSTOP | WS_VISIBLE | WS_CHILD | LVS_SHAREIMAGELISTS | 
		LVS_ALIGNTOP | LVS_REPORT,
		x, y, 60+60, 80, hWnd, (HMENU)50200, g_hInstance, NULL);
	x += 60;

	ListView_SetImageList (hItem[6], himl, LVSIL_NORMAL);

	LVCOLUMN lvc;
	lvc.mask     = LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
	lvc.fmt      = LVCFMT_LEFT;
	lvc.cx       = 56;
	lvc.pszText  = TEXT("Name");
	lvc.iSubItem = 0;
	ListView_InsertColumn (hItem[6], 0, &lvc);
	lvc.fmt      = LVCFMT_LEFT;
	lvc.cx       = 56;
	lvc.pszText  = TEXT("Data");
	lvc.iSubItem = 1;
	ListView_InsertColumn (hItem[6], 1, &lvc);

	LVITEM lvi;
	lvi.mask     = LVIF_TEXT | TVIF_IMAGE;
	lvi.iItem    = 0;
	lvi.iSubItem = 0;
	lvi.iImage   = 0;
	lvi.pszText  = TEXT("Name");
	lvi.cchTextMax = lstrlen(lvi.pszText);
//	SendMessage (hItem[6], LVM_INSERTITEM, 0, (LPARAM)&lvi);
	ListView_InsertItem (hItem[6], &lvi);

	lvi.mask     = LVIF_TEXT;
	lvi.iImage   = 0;
	lvi.iItem    = 0;
	lvi.iSubItem = 1;
	lvi.pszText  = TEXT("Data");
	lvi.cchTextMax = lstrlen(lvi.pszText);
//	SendMessage (hItem[6], LVM_SETITEM, 0, (LPARAM)&lvi);
	ListView_SetItem (hItem[6], &lvi);

//	MessageBox (hWnd, TEXT("Ex"), TEXT("debug"), MB_OK);
//	dwTick = GetTickCount ();

	MSG msg;
	while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) {
		TranslateMessage (&msg);
		DispatchMessage  (&msg);
	}

	int z = 0;
	int w = 0;
	int fs = 0;
	for (i = 0;; i++) {
		int k;
		for (k = 0; k < 7; k++) {
			if (hItem[k]) {
				if ((i % 5) < 3 && w < 1000) {
					switch (k) {
					case 0:
					case 2:
					case 4:
						wsprintf (buf, TEXT("%d"), rand());
						SetWindowText (hItem[k], buf);
						break;
					case 1:
						wsprintf (buf, TEXT("%d"), rand());
						SendMessage (hItem[k], CB_ADDSTRING, 0, (LPARAM)buf);
						break;
					case 3:
						wsprintf (buf, TEXT("%d"), rand());
						SendMessage (hItem[k], LB_ADDSTRING, 0, (LPARAM)buf);
						break;
					case 5:
						wsprintf (buf, TEXT("%d"), rand());
						tvis.hParent      = NULL;
						tvis.hInsertAfter = TVI_SORT;
						tvis.item.mask    = TVIF_TEXT | TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_CHILDREN;
						tvis.item.pszText = buf;
						tvis.item.iImage  = 0;
						tvis.item.iSelectedImage = 0;
						tvis.item.cChildren = 1;
						TreeView_InsertItem (hItem[k], &tvis);
						break;
					case 6:
						wsprintf (buf, TEXT("%d"), rand());
						lvi.mask     = LVIF_TEXT | TVIF_IMAGE;
						lvi.iItem    = 0;
						lvi.iSubItem = 0;
						lvi.iImage   = 0;
						lvi.pszText  = buf;
						lvi.cchTextMax = lstrlen(lvi.pszText);
						//SendMessage (hItem[k], LVM_INSERTITEM, 0, (LPARAM)&lvi);
						ListView_InsertItem (hItem[k], &lvi);
						wsprintf (buf, TEXT("%d"), rand());
						lvi.mask     = LVIF_TEXT;
						lvi.iItem    = 0;
						lvi.iSubItem = 1;
						lvi.pszText  = buf;
						lvi.cchTextMax = lstrlen(lvi.pszText);
						//SendMessage (hItem[k], LVM_SETITEM, 0, (LPARAM)&lvi);
						ListView_SetItem (hItem[k], &lvi);
						break;
					}
					w++;
				}
				else {
					RECT rect;
					GetWindowRect (hItem[k], &rect);
					if (fs == 0)
						rect.top ++;
					else
						rect.top --;
					z++;
					if ((z % 30) == 29) fs = 1 - fs;

					SetWindowPos (hItem[k], HWND_TOP, rect.left, rect.top, 
						48, 64, SWP_SHOWWINDOW | SWP_NOSIZE);

					if ((z % 10) == 9) 
						ShowWindow (hItem[k], SW_HIDE);
					else
						ShowWindow (hItem[k], SW_SHOW);
				}
				UpdateWindow (hItem[k]);
			}
			else {
				Sleep (100);
			}
		}
		while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) {
			TranslateMessage (&msg);
			DispatchMessage  (&msg);
		}
		//Pbo߂I
		dwNow = GetTickCount ();
		if (dwNow - dwTick >= 10000)
			break;
	//	MessageBox (hWnd, TEXT("Ex"), TEXT("debug"), MB_OK);
	}

	while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) {
		TranslateMessage (&msg);
		DispatchMessage  (&msg);
	}

	for (int k = 0; k < 7; k++) {
		if (hItem[k]) {
			DestroyWindow (hItem[k]);
		}
	}

	//dwNow = GetTickCount ();
	//i = dwNow - dwTick;
	return i;
}

//--------------------------------------
//eXg
DWORD MemoryRandom ()
{
	int size = 65536 * 4;
	TCHAR* p = (TCHAR*)LocalAlloc (LPTR, size);
	if (p == 0) return 0;

	DWORD dwTick;
	DWORD dwNow;

	dwTick = GetTickCount ();

	DWORD i;
	DWORD j;
	int   k;
	int   c;

	for (i = 0;;i++) {
		for (j = 0; j < 1000; j++) {
			k = rand() % size;
			c = p[k];
			k = rand() % size;
			p[k] = c;
		}
		//Pbo߂I
		dwNow = GetTickCount ();
		if (dwNow - dwTick >= 1000)
			break;
	}

	LocalFree (p);

	return i;
}

//--------------------------------------
//PocketPCpj[쐬
#ifdef _POCKETPC
HWND CreateRpCommandBar(HWND hwnd)
{
	SHMENUBARINFO mbi;

	memset(&mbi, 0, sizeof(SHMENUBARINFO));
	mbi.cbSize     = sizeof(SHMENUBARINFO);
	mbi.hwndParent = hwnd;
	mbi.nToolBarId = IDM_MENU;
	mbi.hInstRes   = g_hInstance;
	mbi.nBmpId     = 0;
	mbi.cBmpImages = 0;

	if (!SHCreateMenuBar(&mbi)) 
		return NULL;

	return mbi.hwndMB;
}
#endif

//--------------------------------------
//CEEChE
LRESULT CALLBACK WndProc (HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch( message ) 
	{
	case WM_COMMAND:
		{
			int wmId, wmEvent;
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			switch (wmId) 
			{
			case IDM_BM_ALL:
				SendMessage (hWnd, WM_COMMAND, IDM_BM_INIT, 0);
				SendMessage (hWnd, WM_COMMAND, IDM_BM_DOUBLE, 0);
				SendMessage (hWnd, WM_COMMAND, IDM_BM_PAINT, 0);
				SendMessage (hWnd, WM_COMMAND, IDM_BM_WIND, 0);
				SendMessage (hWnd, WM_COMMAND, IDM_BM_MEM, 0);
				g_nNowBen = -1;
				break;

			case IDM_BM_INIT:
				g_nNowBen = 0;
				UpdateWindow (hWnd);
				g_dwTimes[0] = IntegerCalculation ();
				MessageBeep (-1);
				InvalidateRect (hWnd, NULL, FALSE);
				break;

			case IDM_BM_DOUBLE:
				g_nNowBen = 1;
				UpdateWindow (hWnd);
				g_dwTimes[1] = FloatingPointArithmetic ();
				MessageBeep (-1);
				InvalidateRect (hWnd, NULL, FALSE);
				break;

			case IDM_BM_PAINT:
				g_nNowBen = 2;
				UpdateWindow (hWnd);
				g_dwTimes[2] = PaintingPictures (hWnd);
				MessageBeep (-1);
				InvalidateRect (hWnd, NULL, FALSE);
				break;

			case IDM_BM_WIND:
				g_nNowBen = 3;
				UpdateWindow (hWnd);
				g_dwTimes[3] = WindowsTexts (hWnd);
				MessageBeep (-1);
				InvalidateRect (hWnd, NULL, FALSE);
				break;

			case IDM_BM_MEM:
				g_nNowBen = 4;
				UpdateWindow (hWnd);
				g_dwTimes[4] = MemoryRandom ();
				MessageBeep (-1);
				InvalidateRect (hWnd, NULL, FALSE);
				break;

			case IDM_LOGOUT:
				BenchLog ();
				MessageBox (hWnd, _T("Output \\My Documents\\BMQ.log file."), _T("BMQ"), MB_OK);
				break;

			case IDM_ABOUT:
				DialogBox(g_hInstance, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				break;

			case IDM_EXIT:
				DestroyWindow (hWnd);
				break;

			default:
				return DefWindowProc (hWnd, message, wParam, lParam);
			}
			break;
		}

	case WM_CREATE:
		{
			memset (g_dwTimes, 0, sizeof(g_dwTimes));

#ifdef _POCKETPC
			g_hwndCB = CreateRpCommandBar (hWnd);
#else
	#ifdef _WIN32_WCE
			g_hwndCB = CommandBar_Create (g_hInstance, hWnd, 1);			
			CommandBar_InsertMenubar (g_hwndCB, g_hInstance, IDM_MENU, 0);
			CommandBar_AddAdornments (g_hwndCB, 0, 0);
	#endif
#endif
			break;
		}

	case WM_PAINT:
		{
			PAINTSTRUCT ps;
			HDC hDC;
			TCHAR buf[256];
			int i;
			hDC = BeginPaint (hWnd, &ps);

			int k = 0;
			g_dwTimes[9] = 0;
			for (i = 0; i < 5; i ++) {
				if (g_dwTimes[i]) {
					g_dwTimes[9] += g_dwTimes[i];
					k++;
				}
			}
			if (k) {
				g_dwTimes[9] = g_dwTimes[9] / k;
			}

			RECT rect;
			GetClientRect (hWnd, &rect);

			rect.top    = 24;
			rect.bottom = rect.top + 16 * 8;
			rect.left   = 0;
			rect.right  = 320;

			FillRect (hDC, &rect, (HBRUSH)GetStockObject(WHITE_BRUSH));

			rect.left   = 0;
			rect.right  = 320 - 4;

			wsprintf (buf, TEXT("%s %s"), CpuType, OsVer);
			DrawText (hDC, buf, -1, &rect, DT_LEFT);
			rect.top += 16;

			DrawText (hDC, Platform, -1, &rect, DT_LEFT);
			rect.top += 16;

			rect.left = 12;
			DrawText (hDC, TEXT("Inte."), -1, &rect, DT_LEFT);
			rect.top += 16;
			DrawText (hDC, TEXT("Float"), -1, &rect, DT_LEFT);
			rect.top += 16;
			DrawText (hDC, TEXT("Draw"), -1, &rect, DT_LEFT);
			rect.top += 16;
			DrawText (hDC, TEXT("Window"), -1, &rect, DT_LEFT);
			rect.top += 16;
			DrawText (hDC, TEXT("Memory"), -1, &rect, DT_LEFT);
			rect.top += 16;
			DrawText (hDC, TEXT("Total"), -1, &rect, DT_LEFT);
			rect.top += 16;
			rect.left = 0;

			if (g_nNowBen >= 0) {
				rect.top    = 24 + 16 + 16 + g_nNowBen * 16;
				rect.bottom = rect.top + 16 * 6;
				rect.left   = 0;
				rect.right  = 240;
				DrawText (hDC, TEXT(">"), -1, &rect, DT_LEFT);
			}

			rect.top   = 24 + 16;
			rect.left  = 80;
			rect.right = 160;
			rect.top += 16;
			for (i = 0; i < 5; i ++) {
				wsprintf (buf, TEXT("%d "), g_dwTimes[i]);
				DrawText (hDC, buf, -1, &rect, DT_RIGHT);
				rect.top += 16;
			}
			{
				i = 9;
				wsprintf (buf, TEXT("%d "), g_dwTimes[i]);
				DrawText (hDC, buf, -1, &rect, DT_RIGHT);
				rect.top += 16;
			}
			EndPaint( hWnd, &ps );
			break;
		}

	case WM_DESTROY:
		{
#ifdef _WIN32_WCE
			CommandBar_Destroy (g_hwndCB);
#endif
			PostQuitMessage (0);
			break;
		}
	
	default:
		return DefWindowProc( hWnd, message, wParam, lParam );
	}
	return 0;
}

//--------------------------------------
//o[WE_CAO
LRESULT CALLBACK About( HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam )
{
	switch( message )
	{
		case WM_INITDIALOG:
				return TRUE;

		case WM_COMMAND:
			if( LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL ) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}

//--------------------------------------
void BenchLog ()
{
	TCHAR cFileName[MAX_PATH];
	wsprintf (cFileName, _T("\\My Documents\\BMQ.log"));
	HANDLE hFile = CreateFile (cFileName, GENERIC_WRITE, 0, NULL, 
			OPEN_ALWAYS, 0, NULL);
	if (hFile == INVALID_HANDLE_VALUE) {
		return;
	}

	SetFilePointer (hFile, 0, NULL, FILE_END);

	int len;
	TCHAR buff[MAX_PATH];
	char  sjis[MAX_PATH];
	DWORD dwSize;

	wsprintf (buff, _T("===============================\r\n"));
	len = WideCharToMultiByte(CP_ACP, 0, buff, -1, NULL, 0, NULL, NULL);
	WideCharToMultiByte (CP_ACP, 0, buff, -1, sjis, len, NULL, NULL);
	WriteFile (hFile, sjis, len-1, &dwSize, NULL);

	SYSTEMTIME st;
	GetLocalTime (&st);

	wsprintf (buff, _T("%04d-%02d-%02d %02d:%02d:%02d\r\n"), 
		st.wYear, st.wMonth, st.wDay, st.wHour, st.wMinute, st.wSecond);
	len = WideCharToMultiByte(CP_ACP, 0, buff, -1, NULL, 0, NULL, NULL);
	WideCharToMultiByte (CP_ACP, 0, buff, -1, sjis, len, NULL, NULL);
	WriteFile (hFile, sjis, len-1, &dwSize, NULL);

	wsprintf (buff, _T("-------------------------------\r\n"));
	len = WideCharToMultiByte(CP_ACP, 0, buff, -1, NULL, 0, NULL, NULL);
	WideCharToMultiByte (CP_ACP, 0, buff, -1, sjis, len, NULL, NULL);
	WriteFile (hFile, sjis, len-1, &dwSize, NULL);

	wsprintf (buff, TEXT("CPU Type : %s\r\n"), CpuType);
	len = WideCharToMultiByte(CP_ACP, 0, buff, -1, NULL, 0, NULL, NULL);
	WideCharToMultiByte (CP_ACP, 0, buff, -1, sjis, len, NULL, NULL);
	WriteFile (hFile, sjis, len-1, &dwSize, NULL);

	wsprintf (buff, TEXT("OS Ver.  : %s\r\n"), OsVer);
	len = WideCharToMultiByte(CP_ACP, 0, buff, -1, NULL, 0, NULL, NULL);
	WideCharToMultiByte (CP_ACP, 0, buff, -1, sjis, len, NULL, NULL);
	WriteFile (hFile, sjis, len-1, &dwSize, NULL);

	wsprintf (buff, TEXT("Platform : %s\r\n"), Platform);
	len = WideCharToMultiByte(CP_ACP, 0, buff, -1, NULL, 0, NULL, NULL);
	WideCharToMultiByte (CP_ACP, 0, buff, -1, sjis, len, NULL, NULL);
	WriteFile (hFile, sjis, len-1, &dwSize, NULL);

	WriteFile (hFile, "\r\n", 2, &dwSize, NULL);
	
	int i = 0;
	wsprintf (buff, TEXT(" Inte.  %4d\r\n"), g_dwTimes[i]); i++;
	len = WideCharToMultiByte(CP_ACP, 0, buff, -1, NULL, 0, NULL, NULL);
	WideCharToMultiByte (CP_ACP, 0, buff, -1, sjis, len, NULL, NULL);
	WriteFile (hFile, sjis, len-1, &dwSize, NULL);

	wsprintf (buff, TEXT(" Float  %4d\r\n"), g_dwTimes[i]); i++;
	len = WideCharToMultiByte(CP_ACP, 0, buff, -1, NULL, 0, NULL, NULL);
	WideCharToMultiByte (CP_ACP, 0, buff, -1, sjis, len, NULL, NULL);
	WriteFile (hFile, sjis, len-1, &dwSize, NULL);

	wsprintf (buff, TEXT(" Draw   %4d\r\n"), g_dwTimes[i]); i++;
	len = WideCharToMultiByte(CP_ACP, 0, buff, -1, NULL, 0, NULL, NULL);
	WideCharToMultiByte (CP_ACP, 0, buff, -1, sjis, len, NULL, NULL);
	WriteFile (hFile, sjis, len-1, &dwSize, NULL);

	wsprintf (buff, TEXT(" Window %4d\r\n"), g_dwTimes[i]); i++;
	len = WideCharToMultiByte(CP_ACP, 0, buff, -1, NULL, 0, NULL, NULL);
	WideCharToMultiByte (CP_ACP, 0, buff, -1, sjis, len, NULL, NULL);
	WriteFile (hFile, sjis, len-1, &dwSize, NULL);

	wsprintf (buff, TEXT(" Memory %4d\r\n"), g_dwTimes[i]); i++;
	len = WideCharToMultiByte(CP_ACP, 0, buff, -1, NULL, 0, NULL, NULL);
	WideCharToMultiByte (CP_ACP, 0, buff, -1, sjis, len, NULL, NULL);
	WriteFile (hFile, sjis, len-1, &dwSize, NULL);

	wsprintf (buff, TEXT(" -----------\r\n"));
	len = WideCharToMultiByte(CP_ACP, 0, buff, -1, NULL, 0, NULL, NULL);
	WideCharToMultiByte (CP_ACP, 0, buff, -1, sjis, len, NULL, NULL);
	WriteFile (hFile, sjis, len-1, &dwSize, NULL);

	wsprintf (buff, TEXT(" Total  %4d\r\n"), g_dwTimes[9]);
	len = WideCharToMultiByte(CP_ACP, 0, buff, -1, NULL, 0, NULL, NULL);
	WideCharToMultiByte (CP_ACP, 0, buff, -1, sjis, len, NULL, NULL);
	WriteFile (hFile, sjis, len-1, &dwSize, NULL);


	WriteFile (hFile, "\r\n", 2, &dwSize, NULL);

	CloseHandle (hFile);
}

//--------------------------------------
